"""Initial balance migration

Revision ID: f07df84f7a95
Revises: 
Create Date: 2021-12-19 21:12:53.192267

"""
from alembic import op
import sqlalchemy as sa
import flaschengeist


# revision identifiers, used by Alembic.
revision = "f07df84f7a95"
down_revision = None
branch_labels = ("balance",)
depends_on = "d3026757c7cb"


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table(
        "balance_transaction",
        sa.Column("receiver_id", flaschengeist.models.Serial(), nullable=True),
        sa.Column("sender_id", flaschengeist.models.Serial(), nullable=True),
        sa.Column("author_id", flaschengeist.models.Serial(), nullable=False),
        sa.Column("id", flaschengeist.models.Serial(), nullable=False),
        sa.Column("time", flaschengeist.models.UtcDateTime(), nullable=False),
        sa.Column("amount", sa.Numeric(precision=5, scale=2, asdecimal=False), nullable=False),
        sa.Column("reversal_id", flaschengeist.models.Serial(), nullable=True),
        sa.ForeignKeyConstraint(["author_id"], ["user.id"], name=op.f("fk_balance_transaction_author_id_user")),
        sa.ForeignKeyConstraint(["receiver_id"], ["user.id"], name=op.f("fk_balance_transaction_receiver_id_user")),
        sa.ForeignKeyConstraint(
            ["reversal_id"],
            ["balance_transaction.id"],
            name=op.f("fk_balance_transaction_reversal_id_balance_transaction"),
        ),
        sa.ForeignKeyConstraint(["sender_id"], ["user.id"], name=op.f("fk_balance_transaction_sender_id_user")),
        sa.PrimaryKeyConstraint("id", name=op.f("pk_balance_transaction")),
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table("balance_transaction")
    # ### end Alembic commands ###
